diff options
Diffstat (limited to 'meta/packages/initscripts/initscripts-1.0/urandom')
-rwxr-xr-x | meta/packages/initscripts/initscripts-1.0/urandom | 41 |
1 files changed, 41 insertions, 0 deletions
diff --git a/meta/packages/initscripts/initscripts-1.0/urandom b/meta/packages/initscripts/initscripts-1.0/urandom new file mode 100755 index 0000000000..45c41d758b --- /dev/null +++ b/meta/packages/initscripts/initscripts-1.0/urandom | |||
@@ -0,0 +1,41 @@ | |||
1 | #! /bin/sh | ||
2 | # | ||
3 | # urandom This script saves the random seed between reboots. | ||
4 | # It is called from the boot, halt and reboot scripts. | ||
5 | # | ||
6 | # Version: @(#)urandom 1.33 22-Jun-1998 miquels@cistron.nl | ||
7 | # | ||
8 | |||
9 | test -c /dev/urandom || exit 0 | ||
10 | . /etc/default/rcS | ||
11 | |||
12 | case "$1" in | ||
13 | start|"") | ||
14 | test "$VERBOSE" != no && echo "Initializing random number generator..." | ||
15 | # Load and then save 512 bytes, | ||
16 | # which is the size of the entropy pool | ||
17 | if test -f /var/lib/urandom/random-seed | ||
18 | then | ||
19 | cat /var/lib/urandom/random-seed >/dev/urandom | ||
20 | fi | ||
21 | rm -f /var/lib/urandom/random-seed | ||
22 | umask 077 | ||
23 | dd if=/dev/urandom of=/var/lib/urandom/random-seed count=1 \ | ||
24 | >/dev/null 2>&1 || echo "urandom start: failed." | ||
25 | umask 022 | ||
26 | ;; | ||
27 | stop) | ||
28 | # Carry a random seed from shut-down to start-up; | ||
29 | # see documentation in linux/drivers/char/random.c | ||
30 | test "$VERBOSE" != no && echo "Saving random seed..." | ||
31 | umask 077 | ||
32 | dd if=/dev/urandom of=/var/lib/urandom/random-seed count=1 \ | ||
33 | >/dev/null 2>&1 || echo "urandom stop: failed." | ||
34 | ;; | ||
35 | *) | ||
36 | echo "Usage: urandom {start|stop}" >&2 | ||
37 | exit 1 | ||
38 | ;; | ||
39 | esac | ||
40 | |||
41 | exit 0 | ||